//+------------------------------------------------------------------+ 
//|   TRO_MO_BOXES                                                   | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
 
#property indicator_chart_window

extern bool   Show.Trendlines    = true; 
extern bool   Sound.Alert        = false ;
extern bool   Show.Legend        = true ;
extern int    yIncLegend         = 50 ;

extern int myBars  = 5 ;
extern int myShift = 1 ;
extern int    myThreshold    = 1;
 
extern color  myBoxColor     = Orange;     
 
 

extern color  myUpperTrendLineColor = Red; 
extern int    myUpperTrendLineStyle = STYLE_SOLID;
extern int    myUpperTrendLineWidth = 2;
extern string myUpperSoundFile      = "ahooga.wav";

//extern string myLowerTrendLineName  = "LowerTrendLine001";
extern color  myLowerTrendLineColor = Blue; 
extern int    myLowerTrendLineStyle = STYLE_SOLID;
extern int    myLowerTrendLineWidth = 2;
extern string myLowerSoundFile      = "siren.wav"; 
 
double   p1, p2;
int      i, hh, ll;

string TAG = "MOBOX" ,  BOX, OBJ001, OBJ002, OBJ003, OBJ004, OBJ005, OBJ006 ;  


double O, H, L, C, O1, H1, L1, C1 ; 
 

int    digits, period  ; 
string symbol, tChartPeriod ;  
double point;


double UpperTrendLinePrice, LowerTrendLinePrice, UpperLimit, LowerLimit, xThreshold;

 //+------------------------------------------------------------------+
void init() 
{

   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;  
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }      

   xThreshold   = myThreshold * point ;   
      
   deinit();
  
   OBJ001       = TAG + "001";
   OBJ002       = TAG + "002";  

   

}


                                              
//+------------------------------------------------------------------+
void CreateObjects(string no, color cl) 
{

 
      ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
      ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(no, OBJPROP_COLOR, cl);
      ObjectSet(no, OBJPROP_BACK, True);
  
}

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
{
    
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
      
   return(0);
}
 
//+------------------------------------------------------------------+
void start() 
{
 
   DrawObjects( );
 
   if(Show.Trendlines)
   { 
      DrawPriceTrendLines(OBJ001, Time[hh], Time[0], High[hh], 
                        High[hh], myUpperTrendLineColor, myUpperTrendLineStyle, myUpperTrendLineWidth) ;

      DrawPriceTrendLines(OBJ002, Time[ll], Time[0], Low[ll], 
                        Low[ll], myLowerTrendLineColor, myLowerTrendLineStyle, myLowerTrendLineWidth) ;
   } 
   
      UpperTrendLinePrice = ObjectGetValueByShift(OBJ001, 0);
      
      LowerTrendLinePrice = ObjectGetValueByShift(OBJ002, 0);
           
      UpperLimit = Ask + xThreshold ;
      LowerLimit = Bid - xThreshold ;


   if(Sound.Alert)
   {      
      if( UpperTrendLinePrice >= LowerLimit && UpperTrendLinePrice <= UpperLimit )
      {
         PlaySound(myUpperSoundFile);
      } 
      
      if( LowerTrendLinePrice >= LowerLimit && LowerTrendLinePrice <= UpperLimit )
      {
         PlaySound(myLowerSoundFile);
      } 
            
      
   } // if(Sound.Alert) 
   
   if(Show.Legend) { DoShowLegend () ; }    
   
   
} // void

//+------------------------------------------------------------------+
void DrawObjects() 
{

  for( i = myShift; i < 500 ; i++)
  {
         
         O = iOpen(symbol,period,i);
         H = iHigh(symbol,period,i);
         L = iLow(symbol,period,i);
         C = iClose(symbol,period,i);
          
         O1 = iOpen(symbol,period,i+1);
         H1 = iHigh(symbol,period,i+1);
         L1 = iLow(symbol,period,i+1);
         C1 = iClose(symbol,period,i+1);     
  
  if( H < H1 && L >= L1 )
  { 
  
      hh=Highest(NULL, 0, MODE_HIGH, myBars, i);
      ll=Lowest (NULL, 0, MODE_LOW , myBars, i);  
  
      p1=High[hh];
      p2=Low [ll];
      
      BOX = TAG  ;
      if (ObjectFind(BOX) == -1)     CreateObjects(BOX , myBoxColor);
 
      ObjectSet(BOX, OBJPROP_TIME1 , Time[i] );
      ObjectSet(BOX, OBJPROP_PRICE1, p1);
      ObjectSet(BOX, OBJPROP_TIME2 , Time[i+myBars]);
      ObjectSet(BOX, OBJPROP_PRICE2, p2);
      
   break ;  
  } // if  
  
  } // for
  
} // void

//+------------------------------------------------------------------+
 

void DrawPriceTrendLines(string objname, datetime x1, datetime x2, double y1, 
                        double y2, color lineColor, int style, int width)
  {
    
   ObjectDelete(objname);
   ObjectCreate(objname, OBJ_TREND, 0, x1, y1, x2, y2, 0, 0);
   ObjectSet(objname, OBJPROP_RAY, false);
 
   ObjectSet(objname, OBJPROP_COLOR, lineColor);
   ObjectSet(objname, OBJPROP_STYLE, style);
   ObjectSet(objname, OBJPROP_WIDTH, width);
  }
  

//+------------------------------------------------------------------+  
void DoShowLegend()
{ 
   
   setObject(TAG+"ut","Box Upper " + DoubleToStr(p1, digits) ,30,yIncLegend,myUpperTrendLineColor);    setObject(TAG+"ut1","l",10,yIncLegend,myUpperTrendLineColor     ,"Wingdings");
   setObject(TAG+"us","Box Lower " + DoubleToStr(p2, digits) ,30,yIncLegend+20,myLowerTrendLineColor); setObject(TAG+"us1","l",10,yIncLegend+20,myLowerTrendLineColor     ,"Wingdings");
      
}

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
 
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,0,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,0);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}
  
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 

/*
 
  
Comment(


"no " , no , "\n" ,
 
 
"Time[ll] " , TimeToStr(Time[ll]) , "\n" ,
 

"") ;

 

*/